<?php
namespace WPSecurityNinja\Plugin;

class wf_sn_af_fix_anyone_can_register extends wf_sn_af {
    static function get_label($label) {
        $labels = array(
            'title'   => 'Disable Anyone can register',
            'fixable' => true,
            'info'    => 'Fix will disable the "Anyone can register" option.',
            'msg_ok'  => 'Fix applied successfully.',
            'msg_bad' => 'Unable to apply fix.',
        );
        return array_key_exists($label, $labels) ? $labels[$label] : '';
    }

    static function toggle_fix($enable) {
        $current_setting = get_option('users_can_register');
        $desired_setting = $enable ? 1 : 0;

        if ($current_setting === $desired_setting) {
            return self::get_label('msg_ok');
        }

        if (\update_option('users_can_register', $desired_setting)) {
            self::mark_as_fixed('anyone_can_register');
            return self::get_label('msg_ok');
        } else {
            return self::get_label('msg_bad');
        }
    }

    static function fix() {
        return self::toggle_fix(false);
    }

    static function remove_fix() {
        return self::toggle_fix(true);
    }
}