/* globals jQuery:true, ajaxurl:true, sn_block_ui:true, secninScheduledScanner:true */
/*
 * Security Ninja - Scheduled Scanner add-on
 * (c) Web factory 2015
 * Updated 2020 - Larsik Corp
 */

jQuery(document).ready(function ($) {
  // run tests, via ajax
  jQuery('#sn-ss-test').on('click', function () {
    if (!confirm('Please remember to save settings before testing them. Continue?')) {
      return;
    }
    var data = {
      action: 'sn_ss_cs_test',
      nonce: secninScheduledScanner.nonce
    };
    jQuery('#wf-ss-output').show();

    var startTime = Date.now(); // Capture start time






    var $output = jQuery("#wf-ss-output");
    jQuery.ajax({
      url: ajaxurl,
      type: 'POST',
      data: data,
      success: function (response) {
        clearInterval(timer);
        $output.empty();
        $output.append('<p>Success: ' + response.data.message + '</p>');
      },
      error: function () {
        clearInterval(timer);
        $output.empty();
      }
    });











    // Update timer every second
    var timer = setInterval(function () {
      var elapsedSeconds = Math.floor((Date.now() - startTime) / 1000);
      $("#wf-ss-output #sn-timer").text('Time elapsed: ' + elapsedSeconds + ' seconds');
    }, 1000);



  }); // run tests

  // truncate log table
  jQuery('#wf-sn-ss-truncate-log').on('click', function () {
    var answer = confirm("Are you sure you want to delete all log entries?"); // @i8n
    if (answer) {
      var data = {
        'action': 'sn_ss_truncate_log',
        'nonce': secninScheduledScanner.nonce
      };
      $.post(ajaxurl, data, function (response) {
        if (!response) {
          alert('Bad AJAX response. Please reload the page.');
        } else {
          window.location.reload();
        }
      });
    }
    return false;
  });

  // security ninja results details
  jQuery('.ss-details-sn').on('click', function () {
    var data = {
      'action': 'sn_ss_sn_details',
      'nonce': secninScheduledScanner.nonce,
      'row_id': jQuery(this).attr('data-row-id')
    };
    var timestamp = jQuery(this).attr('data-timestamp');

    $.post(ajaxurl, data, function (response) {
      if (!response) {
        alert('Bad AJAX response. Please reload the page.');
      } else {
        jQuery('#sn-scheduled-scanner').html(response)
          .dialog({ title: 'Security Ninja results from ' + timestamp })
          .dialog('open');
      }
    });
    return false;
  });


  // cores canner results details
  jQuery('.ss-details-cs').on('click', function () {
    var data = {
      action: 'sn_ss_cs_details',
      row_id: jQuery(this).attr('data-row-id'),
      nonce: secninScheduledScanner.nonce
    };
    var timestamp = jQuery(this).attr('data-timestamp');

    $.post(ajaxurl, data, function (response) {
      if (!response) {
        alert('Bad AJAX response. Please reload the page.');
      } else {
        jQuery('#sn-scheduled-scanner').html(response)
          .dialog({
            title: 'Core Scanner results from ' + timestamp
          })
          .dialog('open');
      }
    });
    return false;
  });





  // prepare dialog

  jQuery('#sn-scheduled-scanner').dialog({
    'dialogClass': 'wp-dialog',
    'modal': true,
    'resizable': true,
    'zIndex': 9999,
    'width': 900,
    'height': '550',
    'hide': 'fade',
    'show': 'fade',
    'autoOpen': false,
    'closeOnEscape': true
  });


});