/* globals jQuery:true, ajaxurl:true, whizzie_params:true, whizzie_params:true */
var Whizzie = (function($){
    
    var t;
    var current_step = '';
    var step_pointer = '';
    
    // callbacks from form button clicks.
    var callbacks = {
        do_next_step: function( btn ) {
            do_next_step( btn );
        },
        
        // ** Activate Firewall step
        activate_firewall: function(btn){
            var data = {
                'action': 'secnin_activate_firewall',
                '_ajax_nonce': whizzie_params.nonce
            };
            
            $.get(ajaxurl, data, function(response) {
                
                if (response.success) {
                    do_next_step();
                }
                
            });
        },
        // ** Activate default fixes
        activate_default_fixes: function(btn){
            var data = {
                'action': 'secnin_activate_default_fixes',
                '_ajax_nonce': whizzie_params.nonce
            };
            
            $.get(ajaxurl, data, function(response) {
                
                if (response.success) {
                    do_next_step();
                }
                
            });
            
        }
                
    };

    
    
    
    
    function secnin_window_loaded() {
        // Get all steps and find the biggest
        // Set all steps to same height
        var maxHeight = 0;
        
        $( '.whizzie-menu li.step' ).each( function( index ) {
            $(this).attr( 'data-height', $(this).innerHeight() );
            if( $(this).innerHeight() > maxHeight ) {
                maxHeight = $(this).innerHeight();
            }
        });
        
        $( '.whizzie-menu li .detail' ).each( function( index ) {
            $(this).attr( 'data-height', $(this).innerHeight() );
            $(this).addClass( 'scale-down' );
        });
        
        
        $( '.whizzie-menu li.step' ).css( 'height', maxHeight );
        $( '.whizzie-menu li.step:first-child' ).addClass( 'active-step' );
        $( '.whizzie-nav li:first-child' ).addClass( 'active-step' );
        
        $( '.whizzie-wrap' ).addClass( 'loaded' );
        
        // init button clicks:
        $('.do-it').on( 'click', function(e) {
            e.preventDefault();
            step_pointer = $(this).data('step');
            current_step = $('.step-' + $(this).data('step'));
            $('.whizzie-wrap').addClass( 'spinning' );
            
            if($(this).data('callback') && typeof callbacks[$(this).data('callback')] !== 'undefined'){
                // we have to process a callback before continue with form submission
                callbacks[$(this).data('callback')](this);
                return false;
            } else {
                return true;
            }
        });

        $( '.more-info' ).on( 'click', function( e ) {
            e.preventDefault();
            var parent = $(this).parent().parent();
            parent.toggleClass( 'show-detail' );
            if( parent.hasClass( 'show-detail' ) ) {
                var detail = parent.find('.detail');
                parent.animate({
                    height: parent.data( 'height' ) + detail.data( 'height' )
                },
                500,
                function(){
                    detail.toggleClass( 'scale-down' );
                }).css( 'overflow', 'visible' );
            } else {
                parent.animate({
                    height: maxHeight
                },
                500,
                function(){
                    detail = parent.find('.detail');
                    detail.toggleClass( 'scale-down' );
                }).css( 'overflow', 'visible' );
            }
        });
    }
    
    /**
     * Process next step, go to next step in wizard.
     *
     * @author	Unknown
     * @since	v0.0.1
     * @version	v1.0.0	Thursday, March 3rd, 2022.
     * @param	mixed	btn	
     * @return	void
     */
    function do_next_step( btn ) {
        current_step.removeClass( 'active-step' );
        $( '.nav-step-' + step_pointer ).removeClass( 'active-step' );
        current_step.addClass( 'done-step' );
        $( '.nav-step-' + step_pointer ).addClass( 'done-step' );
        current_step.fadeOut( 500, function() {
            current_step = current_step.next();
            step_pointer = current_step.data( 'step' );
            current_step.fadeIn();
            current_step.addClass( 'active-step' );
            $( '.nav-step-' + step_pointer ).addClass( 'active-step' );
            $('.whizzie-wrap').removeClass( 'spinning' );
        });
    }
    
    return {
        init: function(){
            t = this;
            $(secnin_window_loaded);
        },
        callback: function(func){
            console.log(func);
            console.log(this);
        }
    };
    
})(jQuery);

jQuery(document).ready(function(){
    // Lets load when the page is ready
    Whizzie.init();
});